using System;
using System.Collections.Generic;
using System.Text;
using LibJasinski.Network;
using System.Text.RegularExpressions;

namespace DesktopText
{
	class WeatherGetter : WebScraper
	{
		private static WeatherGetter _default;
		static WeatherGetter()
		{
			_default = new WeatherGetter();
		}
		public static WeatherGetter Default
		{
			get { return _default; }
		}

		private string _temperature;
		private string _conditions;
		private DateTime _timeStamp;

		public string Temperature
		{
			get { return _temperature; }
		}
		public string Conditions
		{
			get { return _conditions; }
		}
		public DateTime TimeStamp
		{
			get { return _timeStamp; }
		}
		public bool Get()
		{
			//string url = @"http://forecast.weather.gov/MapClick.php?CityName=Atlanta&state=GA&site=FFC&textField1=33.7629&textField2=-84.4226&e=1";
			//string pattern = ">(?<conditions>.+?)<br><br>(?<temperature>[0-9]{1,3}) &deg;F<br";
			string url = Cfg.Def.WeatherUrl;
			string pattern = Cfg.Def.WeatherRegex;
			bool result = false;
			
			if (base.Get(url, pattern))
			{
				MatchCollection mc = base.Matches;
				if (mc.Count > 0)
				{
					_temperature = mc[0].Groups["temperature"].Value.Trim();
					_conditions = mc[0].Groups["conditions"].Value.Trim();
					_timeStamp = DateTime.Now;
					result = true;
				}
			}

			return result;
		}
	}
}
